
<template>
  <q-page class="flex">
    <div class="doc-container col-12">
      <div class="minheight-rows">
        <div class="row title-row items-center margin-bottom-20">
          <i class="fas fa-th-large"></i>
          <div class="page-title">{{ title }}</div>
        </div>
        <div class="row title-row justify-end margin-bottom-20">
          <i class="fas fa-hdd">&nbsp;</i>
          <div class="page-info">
            {{ disk_info.free_disk }}/{{ disk_info.total_disk }} GB
          </div>
        </div>
        <div class="row gutter-xs justify-center margin-bottom-20">
          <div class="col-12">
            <q-table
              :title="$t('content.available')"
              :data="available_contents"
              :columns="columns"
              :visible-columns="visible_columns"
              :filter="filt"
              :filter-method="tableFilter"
              row-key="content_id"
              selection="multiple"
              :selected.sync="available_selected"
            >
              <template slot="top-right" slot-scope="props">
                <q-select
                  :stack-label="$t('Subject')"
                  v-model="filt.subject"
                  :options="available_subjects"
                />
                <q-select
                  :stack-label="$t('Language')"
                  v-model="filt.language"
                  :options="available_languages"
                />
              </template>
              <template slot="top-selection" slot-scope="props">
                <q-btn
                  color="secondary"
                  flat
                  :label="$t('state.Install')"
                  class="q-mr-sm"
                  @click="installContents"
                />
              </template>
            </q-table>
          </div>
        </div>
        <div class="row gutter-xs justify-center margin-bottom-20">
          <div class="col-12">
            <q-table
              :title="$t('content.installed')"
              :data="installed_contents"
              :columns="columns"
              :visible-columns="visible_columns"
              row-key="content_id"
              selection="multiple"
              :selected.sync="installed_selected"
            >
              <template slot="top-selection" slot-scope="props">
                <q-btn
                  color="secondary"
                  flat
                  :label="$t('state.Uninstall')"
                  class="q-mr-sm"
                  @click="uninstallContents"
                />
              </template>
            </q-table>
          </div>
        </div>
        <div class="row gutter-xs justify-center margin-bottom-20">
          <div class="col-12">
            <q-table
              :title="$t('content.upgradable')"
              :data="upgradable_contents"
              :columns="columns"
              :visible-columns="visible_columns"
              row-key="content_id"
              selection="multiple"
              :selected.sync="upgradable_selected"
            >
              <template slot="top-selection" slot-scope="props">
                <q-btn
                  color="secondary"
                  flat
                  :label="$t('state.Upgrade')"
                  class="q-mr-sm"
                  @click="upgradeContents"
                />
              </template>
            </q-table>
          </div>
        </div>
        <div class="row gutter-xs justify-center margin-bottom-20">
          <div class="col-12">
            <q-table
              :title="$t('content.broken')"
              :data="broken_contents"
              :columns="columns"
              :visible-columns="visible_columns"
              row-key="content_id"
              selection="multiple"
              :selected.sync="broken_selected"
            >
              <template slot="top-selection" slot-scope="props">
                <q-btn
                  color="secondary"
                  flat
                  :label="$t('content.reinstall')"
                  class="q-mr-sm"
                  @click="reinstallContents"
                />
              </template>
            </q-table>
          </div>
        </div>
      </div>
    </div>
  </q-page>
</template>

<script>
import {mapActions, mapState} from 'vuex'
import _ from 'lodash'

export default {
  name: 'Users',
  data: () => ({
    filt: {
      language: null,
      subject: null
    },
    visible_columns: [
      'name',
      'description',
      'state',
      'size'
    ],
    available_selected: [],
    installed_selected: [],
    upgradable_selected: [],
    broken_selected: []
  }),
  methods: {
    ...mapActions('applications', [
      'listContentForBundle',
      'triggerContentsTargetStateChange',
      'triggerContentUpgrade',
      'getFreeDiskSpace'
    ]),
    installContents: function () {
      let contentIds = _.map(this.available_selected, e => e.content_id)
      this.triggerContentsTargetStateChange({bundle: this.$route.params.bundle, contentIds, newState: 'installed'})
      this.available_selected = []
    },
    reinstallContents: function () {
      let contentIds = _.map(this.broken_selected, e => e.content_id)
      this.triggerContentsTargetStateChange({bundle: this.$route.params.bundle, contentIds, newState: 'installed'})
      this.broken_selected = []
    },
    uninstallContents: function () {
      let contentIds = _.map(this.installed_selected, e => e.content_id)
      this.triggerContentsTargetStateChange({bundle: this.$route.params.bundle, contentIds, newState: 'uninstalled'})
      this.installed_selected = []
    },
    upgradeContents: function () {
      let contentIds = _.map(this.upgradable_selected, e => e.content_id)
      this.triggerContentUpgrade({bundle: this.$route.params.bundle, contentIds})
      this.upgradable_selected = []
    },
    refreshLists: function () {
      let bundle = this.$route.params.bundle
      this.listContentForBundle(bundle)
    },
    enableRefreshTimeout: function () {
      this.timeoutInterval = setInterval(() => {
        this.refreshLists()
        this.getFreeDiskSpace()
      }, 5000)
    },
    tableFilter (rows, terms, cols, cellValue) {
      let compiledResults = rows
      if (terms.subject || terms.language) {
        for (var k in terms) {
          if (terms[k]) {
            compiledResults = compiledResults.filter(row => row[k] === terms[k])
          }
        }
      }
      return compiledResults
    }
  },
  computed: mapState('applications', {
    application: function (state) {
      return _.find(state.installed_applications, a => a.bundle === this.$route.params.bundle)
    },
    available_contents: function (state) {
      if (this.application && this.application.contents) {
        return _.filter(this.application.contents, c => c.currentState === 'uninstalled')
      } else {
        return []
      }
    },
    installed_contents: function (state) {
      if (this.application && this.application.contents) {
        return _.filter(this.application.contents, c => c.currentState === 'installed')
      } else {
        return []
      }
    },
    upgradable_contents: function (state) {
      if (this.application && this.application.contents) {
        return _.filter(this.application.contents, c => c.currentState === 'installed' &&
          c.repositoryVersion != null &&
          c.currentVersion !== c.repositoryVersion)
      } else {
        return []
      }
    },
    broken_contents: function (state) {
      if (this.application && this.application.contents) {
        return _.filter(this.application.contents, c => c.targetState === 'broken' &&
          c.repositoryVersion != null)
      } else {
        return []
      }
    },
    available_languages: function (state) {
      if (this.application && this.application.contents) {
        const langs = this.application.contents.map(c => c.language)
        let uniqLangs = [...new Set(langs)]

        let res = [{
          'label': null,
          'value': null
        }]
        uniqLangs.forEach(function (l) {
          let opt = {}
          opt['label'] = l
          opt['value'] = l
          res.push(opt)
        })
        return res
      } else {
        return []
      }
    },
    available_subjects: function (state) {
      if (this.application && this.application.contents) {
        const subjects = this.application.contents.map(c => c.subject)
        let uniqSubjects = [...new Set(subjects)]

        let res = [{
          'label': null,
          'value': null
        }]
        uniqSubjects.forEach(function (s) {
          let opt = {}
          opt['label'] = s
          opt['value'] = s
          if (opt['label'] || opt['value']) {
            res.push(opt)
          }
        })
        return res
      } else {
        return []
      }
    },
    title: function (state) {
      if (this.application) {
        return this.$t('content.title') + this.application.name
      } else {
        return this.$t('content.list')
      }
    },
    contents: function (state) {
      if (this.application && this.application.contents) {
        return this.application.contents
      } else {
        return []
      }
    },
    disk_info: (state) => state.sysinfo,
    columns: function () {
      return [
        {
          name: 'content_id',
          label: 'Id',
          required: false,
          visible: false,
          field: 'content_id',
          align: 'left'
        },
        {
          name: 'name',
          label: this.$t('Name'),
          required: true,
          sortable: true,
          field: 'name',
          align: 'left',
          style: 'white-space: normal; max-width: 10%'
        },
        {
          name: 'description',
          label: this.$t('Description'),
          required: false,
          sortable: false,
          field: 'description',
          align: 'left',
          style: 'white-space: normal; max-width: 70%'
        },
        {
          name: 'state',
          label: this.$t('state.id'),
          required: true,
          sortable: false,
          field: (row) => {
            if (row.currentState === 'uninstalled' && row.targetState === 'broken') {
              return this.$t('state.broken')
            }
            if (
              row.currentState === 'uninstalled' &&
              row.targetState === 'uninstalled'
            ) {
              return this.$t('state.uninstalled')
            }
            if (
              row.currentState === 'uninstalled' &&
              row.targetState === 'installed'
            ) {
              return this.$t('state.installing')
            }
            if (
              row.currentState === 'installed' &&
              row.targetState === 'uninstalled'
            ) {
              return this.$t('state.uninstalling')
            }
            if (
              row.currentState === 'installed' &&
              row.currentVersion !== row.repositoryVersion &&
              row.targetVersion === row.repositoryVersion
            ) {
              return this.$t('state.upgrading')
            }
            return this.$t('state.installed')
          },
          align: 'left',
          style: 'max-width: 10%'
        },
        {
          name: 'size',
          label: this.$t('Size'),
          required: false,
          sortable: false,
          field: (row) => {
            var sizes = [this.$t('bytes'), 'KB', 'MB', 'GB', 'TB']
            if (row.size === 0) return '0b'
            var i = parseInt(Math.floor(Math.log(row.size) / Math.log(1024)))
            if (i === 0) return row.size + ' ' + sizes[i]
            return (row.size / Math.pow(1024, i)).toFixed(1) + ' ' + sizes[i]
          },
          align: 'left',
          style: 'max-width: 10%'
        }
      ]
    }
  }),
  mounted: function () {
    this.refreshLists()
    this.enableRefreshTimeout()
  },
  destroyed: function () {
    clearInterval(this.timeoutInterval)
  }
}
</script>
